`define WIDTH 7

module anti_chattering(
	input wire nRST,
	input wire CLK, // 100Hz
	input wire INP,
	output wire OUTP_HI,
	output wire OUTP_LO
);

	reg [`WIDTH - 1:0] regist;
	reg is_after_reset;

	assign OUTP_HI = &regist;
	assign OUTP_LO = (|regist) | is_after_reset;

	always @(posedge CLK or negedge nRST) begin
		if( ~nRST ) begin
			regist <= `WIDTH'd0;
			is_after_reset <= 1;
		end
		else begin
			regist <= {regist[`WIDTH - 2:0], INP};
			is_after_reset <= 0;
		end

	end

endmodule
