module counter60_bcd_down_with_en(
	input wire nRST,
	input wire CLK,
	input wire EN, // Normally, input a pulse that has the same width with CLK
	input wire INCR,
	input wire DECR,
	output reg [3:0] NUMBER_1,
	output reg [2:0] NUMBER_10,
	output wire FULL
);

	assign FULL = (NUMBER_1 == 4'd0 && NUMBER_10 == 3'd0);

	always @(posedge CLK or negedge nRST) begin
		if( ~nRST ) begin
			NUMBER_1  <= 4'd0;
			NUMBER_10 <= 3'd0;
		end
		else if ( INCR ) begin
			NUMBER_1 <= (NUMBER_1 + 4'd1) % 10;
			NUMBER_10 <= (NUMBER_1 == 4'd9) ? (NUMBER_10 + 3'd1) % 6 : NUMBER_10;
		end
		else if ( DECR ) begin
			NUMBER_1 <= (NUMBER_1 - 4'd1 + 4'd10) % 10;
			NUMBER_10 <= (NUMBER_1 == 4'd0) ? (NUMBER_10 - 3'd1 + 3'd6) % 6 : NUMBER_10;
		end
		else if ( EN ) begin
			if( NUMBER_1 == 4'd0 && NUMBER_10 == 3'd0 ) begin
				NUMBER_1 <= 4'd9;
				NUMBER_10 <= 3'd5;
			end
			else if( NUMBER_1 == 4'd0 ) begin // (x:0) (x != 0)
				NUMBER_1 <= 4'd9;
				NUMBER_10 <= (NUMBER_10 - 3'd1) % 10;
			end
			else begin
				NUMBER_1 <= (NUMBER_1 - 4'd1) % 10;
				NUMBER_10 <= NUMBER_10;
			end
		end
		else begin
			NUMBER_1 <= NUMBER_1;
			NUMBER_10 <= NUMBER_10;
		end
	end

	endmodule
