module duty_buffer(
	input wire nRST,
	input wire CLK,
	input wire [6:0] DUTY,
	input wire DATA,
	output reg OUTPUT
);

	reg [6:0] counter;

	always @(posedge CLK or negedge nRST) begin
		if( ~nRST ) begin
			OUTPUT <= 0;
			counter <= 7'b0;
		end
		else begin
			counter <= (counter != 7'd99) ? counter + 7'b1 : 7'd0;
			if( counter == DUTY ) begin
				OUTPUT <= 0;
			end
			else if( counter == 7'd0 ) begin
				OUTPUT <= DATA;
			end
		end

	end

endmodule
