module posedge_trigger(
	input wire nRST,
	input wire CLK,
	input wire INP,
	output reg OUTP
);

/*
	Mehtod: catch L -> H.
	when INP is LLLLHHHL, prev is 00 -> 01 -> 11 -> 10 -> 00

	NOTE: If input is connected to some mechanical SW or terminal, eliminate chattering in advance.
*/

	reg [1:0] prev;

	always @(posedge CLK or negedge nRST ) begin
		if( ~nRST ) begin
			prev <= 2'd0;
			OUTP <= 0;
		end
		else begin
			prev <= {prev[0], INP};
			OUTP <= prev[0] & ~prev[1];
		end

	end

endmodule
